ghc-7.8.4: The GHC API

Safe Haskell | None
Language | Haskell98

FunDeps

# Documentation

data FDEq

Constructors

FDEq |

Fields

fd_pos :: Int
fd_ty_left :: Type
fd_ty_right :: Type

Instances

Outputable FDEq |

data Equation

Constructors

FDEqn |

Fields

fd_qtvs :: [TyVar]
fd_eqs :: [FDEq]
fd_pred1 :: PredType
fd_pred2 :: PredType

pprEquation :: Equation -> SDoc

improveFromInstEnv :: (InstEnv, InstEnv) -> PredType -> [Equation]

improveFromAnother :: PredType -> PredType -> [Equation]

checkInstCoverage :: Bool -> Class -> [PredType] -> [Type] -> Maybe SDoc

checkFunDeps :: (InstEnv, InstEnv) -> ClsInst -> Maybe [ClsInst]

growThetaTyVars :: ThetaType -> TyVarSet -> TyVarSet

pprFundeps :: Outputable a => [FunDep a] -> SDoc